import 'package:fcs/domain/entities/box.dart';
import 'package:fcs/pages/main/util.dart';
import 'package:fcs/pages/widgets/bottom_up_page_route.dart';
import 'package:flutter/material.dart';
import 'package:intl/intl.dart';

import 'box_editor.dart';

class BoxListRow extends StatefulWidget {
  final bool isReadOnly;
  final Box box;
  const BoxListRow({this.box, this.isReadOnly});

  @override
  _BoxListRowState createState() => _BoxListRowState();
}

class _BoxListRowState extends State<BoxListRow> {
  final double dotSize = 15.0;
  Box _box = new Box();
  final DateFormat dateFormat = new DateFormat("dd MMM yyyy");

  @override
  void initState() {
    super.initState();
    _box = widget.box;
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      padding: EdgeInsets.only(left: 15, right: 15),
      child: InkWell(
        onTap: () {
          if (widget.isReadOnly) {
            // Navigator.push(
            //   context,
            //   BottomUpPageRoute(PackageInfo(package: _box)),
            // );
          } else {
            Navigator.push(
              context,
              BottomUpPageRoute(BoxEditor(box: _box)),
            );
          }
        },
        child: Row(
          children: <Widget>[
            Expanded(
              child: new Padding(
                padding: const EdgeInsets.symmetric(vertical: 16.0),
                child: new Row(
                  children: <Widget>[
                    new Expanded(
                      child: new Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: <Widget>[
                          Padding(
                            padding: const EdgeInsets.only(left: 8.0),
                            child: new Text(
                              _box.packageNumber == null
                                  ? ''
                                  : _box.packageNumber,
                              style: new TextStyle(
                                  fontSize: 15.0, color: Colors.black),
                            ),
                          ),
                          Padding(
                            padding: const EdgeInsets.only(left: 10.0, top: 10),
                            child: new Text(
                              dateFormat.format(_box.arrivedDate),
                              style: new TextStyle(
                                  fontSize: 15.0, color: Colors.grey),
                            ),
                          )
                        ],
                      ),
                    ),
                  ],
                ),
              ),
            ),
            Column(
              children: <Widget>[
                Padding(
                  padding: const EdgeInsets.all(0),
                  child: getStatus(_box.status),
                ),
                Padding(
                  padding: const EdgeInsets.only(left: 8.0, top: 5, bottom: 5),
                  child: Row(
                    children: <Widget>[
                      new Text(
                        _box.weight == null
                            ? ''
                            : _box.weight.toString() + 'lb - ',
                        style:
                            new TextStyle(fontSize: 15.0, color: Colors.grey),
                      ),
                      new Text(
                        _box.price == null ? "" : "\$ " + _box.price.toString(),
                        style:
                            new TextStyle(fontSize: 15.0, color: Colors.grey),
                      ),
                    ],
                  ),
                ),
              ],
            )
          ],
        ),
      ),
    );
  }
}
